Main Page Widgets Namespaces Book

# Gdk::GC Class Reference

Inheritance diagram for Gdk::GC:

[legend]
List of all members.

## Detailed Description

All drawing operations in GDK take a graphics context (GC) argument.

A graphics context encapsulates information about the way things are drawn, such as the foreground color or line width. By using graphics contexts, the number of arguments to each drawing call is greatly reduced, and communication overhead is minimized, since identical arguments do not need to be passed repeatedly.

## Public Member Functions

virtual | ~GC ()
GdkGC* | gobj ()
| Provides access to the underlying C GObject.
const GdkGC* | gobj () const
| Provides access to the underlying C GObject.
GdkGC* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_foreground (const Color& color)
void | set_background (const Color& color)
void | set_function (Function function)
void | set_fill (Fill fill)
void | set_tile (const Glib::RefPtr<Pixmap>& tile)
void | set_stipple (const Glib::RefPtr<Pixmap>& stipple)
void | set_ts_origin (int x, int y)
void | set_clip_origin (int x, int y)
void | set_clip_mask (const Glib::RefPtr<Bitmap>& mask)
void | set_clip_rectangle (Rectangle& rectangle)
void | set_clip_region (const Region& region)
void | set_subwindow (SubwindowMode mode)
void | set_exposures (bool exposures)
void | set_line_attributes (int line_width, LineStyle line_style, CapStyle cap_style, JoinStyle join_style)
void | set_dashes (int dash_offset, gint8* dash_list, int n)
void | offset (int x_offset, int y_offset)
| Offset attributes such as the clip and tile-stipple origins of the GC so that drawing at x - x_offset, y - y_offset with the offset GC has the same effect as drawing at x, y with the original GC.
void | set_colormap (const Glib::RefPtr<Colormap>& colormap)
| Sets the colormap for the GC to the given colormap.
Glib::RefPtr<Colormap> | get_colormap ()
| Retrieves the colormap for a given GC, if it exists.
void | set_rgb_fg_color (const Color& color)
| Set the foreground color of a GC using an unallocated color.
void | set_rgb_bg_color (const Color& color)
| Set the background color of a GC using an unallocated color.
Glib::RefPtr<Screen> | get_screen ()
| Gets the Gdk::Screen for which gc was created.
Glib::RefPtr<const Screen> | get_screen () const
| Gets the Gdk::Screen for which gc was created.

## Static Public Member Functions

Glib::RefPtr<GC> | create ()
Glib::RefPtr<GC> | create (const Glib::RefPtr<Drawable>& drawable)

## Protected Member Functions

| GC ()
| GC (const Glib::RefPtr<Drawable>& drawable)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr<Gdk::GC> | wrap (GdkGC* object, bool take_copy=false)

## Constructor & Destructor Documentation

virtual Gdk::GC::~GC | ( |  | ) | `[virtual]`

Gdk::GC::GC | ( |  | ) | `[protected]`

Gdk::GC::GC | ( | const Glib::RefPtr<Drawable>& | drawable | ) | `[explicit, protected]`

## Member Function Documentation

Glib::RefPtr<GC> Gdk::GC::create | ( | const Glib::RefPtr<Drawable>& | drawable | ) | `[static]`

Glib::RefPtr<GC> Gdk::GC::create | ( |  | ) | `[static]`

Glib::RefPtr<Colormap> Gdk::GC::get_colormap | ( |  | ) |

| Retrieves the colormap for a given GC, if it exists. A GC will have a colormap if the drawable for which it was created has a colormap, or if a colormap was set explicitely with gdk_gc_set_colormap.

Glib::RefPtr<const Screen> Gdk::GC::get_screen | ( |  | ) | const

Gets the Gdk::Screen for which gc was created.

Returns:
  The Gdk::Screen for gc .

Since: 2.2.

Glib::RefPtr<Screen> Gdk::GC::get_screen | ( |  | ) |

Gets the Gdk::Screen for which gc was created.

Returns:
  The Gdk::Screen for gc .

Since: 2.2.

const GdkGC* Gdk::GC::gobj | ( |  | ) | const`[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::ObjectBase.

GdkGC* Gdk::GC::gobj | ( |  | ) | `[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::ObjectBase.

GdkGC* Gdk::GC::gobj_copy | ( |  | ) |

| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

void Gdk::GC::offset | ( | int | x_offset,
|  | int | y_offset
| ) |

Offset attributes such as the clip and tile-stipple origins of the GC so that drawing at x - x_offset, y - y_offset with the offset GC has the same effect as drawing at x, y with the original GC.

Parameters:

  | x_offset | Amount by which to offset the GC in the X direction.
  | y_offset | Amount by which to offset the GC in the Y direction.

void Gdk::GC::set_background | ( | const Color& | color | ) |

void Gdk::GC::set_clip_mask | ( | const Glib::RefPtr<Bitmap>& | mask | ) |

void Gdk::GC::set_clip_origin | ( | int | x,
|  | int | y
| ) |

void Gdk::GC::set_clip_rectangle | ( | Rectangle& | rectangle | ) |

void Gdk::GC::set_clip_region | ( | const Region& | region | ) |

void Gdk::GC::set_colormap | ( | const Glib::RefPtr<Colormap>& | colormap | ) |

Sets the colormap for the GC to the given colormap.

The depth of the colormap's visual must match the depth of the drawable for which the GC was created.

Parameters:

  | colormap | A Gdk::Colormap.

void Gdk::GC::set_dashes | ( | int | dash_offset,
|  | gint8* | dash_list,
|  | int | n
| ) |

void Gdk::GC::set_exposures | ( | bool | exposures | ) |

void Gdk::GC::set_fill | ( | Fill | fill | ) |

void Gdk::GC::set_foreground | ( | const Color& | color | ) |

void Gdk::GC::set_function | ( | Function | function | ) |

void Gdk::GC::set_line_attributes | ( | int | line_width,
|  | LineStyle | line_style,
|  | CapStyle | cap_style,
|  | JoinStyle | join_style
| ) |

void Gdk::GC::set_rgb_bg_color | ( | const Color& | color | ) |

Set the background color of a GC using an unallocated color.

The pixel value for the color will be determined using GdkRGB. If the colormap for the GC has not previously been initialized for GdkRGB, then for pseudo-color colormaps (colormaps with a small modifiable number of colors), a colorcube will be allocated in the colormap.

Calling this function for a GC without a colormap is an error.

Parameters:

  | color | An unallocated Gdk::Color.

void Gdk::GC::set_rgb_fg_color | ( | const Color& | color | ) |

Set the foreground color of a GC using an unallocated color.

The pixel value for the color will be determined using GdkRGB. If the colormap for the GC has not previously been initialized for GdkRGB, then for pseudo-color colormaps (colormaps with a small modifiable number of colors), a colorcube will be allocated in the colormap.

Calling this function for a GC without a colormap is an error.

Parameters:

  | color | An unallocated Gdk::Color.

void Gdk::GC::set_stipple | ( | const Glib::RefPtr<Pixmap>& | stipple | ) |

void Gdk::GC::set_subwindow | ( | SubwindowMode | mode | ) |

void Gdk::GC::set_tile | ( | const Glib::RefPtr<Pixmap>& | tile | ) |

void Gdk::GC::set_ts_origin | ( | int | x,
|  | int | y
| ) |

## Friends And Related Function Documentation

Glib::RefPtr<Gdk::GC> wrap | ( | GdkGC* | object,
|  | bool | take_copy = `false`
| ) | `[related]`

Parameters:

  | object | The C instance
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gc.h